<?php

namespace Drupal\layoutbuilder_extras_live_update\Form;

use Drupal\Core\Form\ConfigFormBase;
use Drupal\Core\Form\FormStateInterface;

/**
 * Settings form.
 */
class LayoutBuilderExtrasLiveUpdateSettingsForm extends ConfigFormBase {

  const SETTINGSNAME = 'layoutbuilder_extras_live_update.settings';

  /**
   * {@inheritdoc}
   */
  public function getFormId() {
    return 'layoutbuilder_extras_live_update';
  }

  /**
   * {@inheritdoc}
   */
  protected function getEditableConfigNames() {
    return [
      self::SETTINGSNAME,
    ];
  }

  /**
   * {@inheritdoc}
   */
  public function buildForm(array $form, FormStateInterface $form_state) {
    $form = parent::buildForm($form, $form_state);

    $config = $this->config(self::SETTINGSNAME);

    $form['disable_removal_submit'] = [
      '#type' => 'checkbox',
      '#title' => $this->t('Disable the UX improvement to remove the submit button'),
      '#description' => $this->t('Layout builder extras tries to update everthing, but in some cases like currently with EntityBrowser it is not supported. This bypasses the removal of that submit button so it still works.'),
      '#default_value' => $config->get('disable_removal_submit') ?? TRUE,
    ];

    return $form;
  }

  /**
   * {@inheritdoc}
   */
  public function submitForm(array &$form, FormStateInterface $form_state) {
    parent::submitForm($form, $form_state);
    $config = $this->configFactory->getEditable(self::SETTINGSNAME);

    $config->set('disable_removal_submit', $form_state->getValue('disable_removal_submit', TRUE));

    $config->save();
  }

}
